```@meta
CurrentModule = Oscar
DocTestSetup = quote
  using Oscar
end
```

```@setup oscar
using Oscar
```

```@contents
Pages = ["intro.md"]
```

# Introduction

The fields part of OSCAR provides functionality for handling
various kinds of fields:
- the field of rationals
- Number fields
- [Generic fraction fields](@ref)
- local fields ([Padics](@ref) and [Qadics](@ref))
- finite fields

General textbooks offering details on theory and algorithms include:
- [Coh93](@cite)
- [Coh00](@cite)
- [LN97](@cite)
- [Mar18](@cite)
- [PZ97](@cite)


## Contact

Please direct questions about this part of OSCAR to the following people:
* [Claus Fieker](https://www.mathematik.uni-kl.de/en/agag/people/head/prof-dr-claus-fieker),
* [Tommy Hofmann](https://www.thofma.com/),
* [Max Horn](https://www.mathematik.uni-kl.de/en/agag/people/head/prof-dr-max-horn).

You can ask questions in the [OSCAR Slack](https://www.oscar-system.org/community/#slack).

Alternatively, you can [raise an issue on github](https://www.oscar-system.org/community/#how-to-report-issues).
