```@meta
CurrentModule = Oscar
DocTestSetup = quote
  using Oscar
end
```

```@setup oscar
using Oscar
```

```@contents
Pages = ["intro.md"]
```

# Introduction

The groups part of OSCAR provides functionality for handling
- [Permutation groups](@ref)
- [Matrix groups](@ref)
- [Finitely presented groups](@ref)
- [Polycyclic groups](@ref)
- [Products of groups](@ref)
- [Groups of automorphisms](@ref)

General textbooks offering details on theory and algorithms include:
- [Hup67](@cite)
- [HEO05](@cite)


## Contact

Please direct questions about this part of OSCAR to the following people:
* [Thomas Breuer](https://www.math.rwth-aachen.de/homes/Thomas.Breuer/),
* [Max Horn](https://www.mathematik.uni-kl.de/en/agag/people/head/prof-dr-max-horn).

You can ask questions in the [OSCAR Slack](https://www.oscar-system.org/community/#slack).

Alternatively, you can [raise an issue on github](https://www.oscar-system.org/community/#how-to-report-issues).
