```@meta
CurrentModule = Oscar
DocTestSetup = quote
  using Oscar
end
```

```@setup oscar
using Oscar
```

```@contents
Pages = ["intro.md"]
```

# Introduction

The rings part of OSCAR provides functionality for handling
various kinds of rings: 
- the ring of integers
- polynomial rings (univariate and multivariate, see [Generic univariate polynomial types](@ref) and [Generic sparse distributed multivariable polynomial types](@ref)),
- orders in number fields
- series rings

General textbooks offering details on theory and algorithms include:
- ...


## Contact

Please direct questions about this part of OSCAR to the following people:
* [Claus Fieker](https://www.mathematik.uni-kl.de/en/agag/people/head/prof-dr-claus-fieker),
* [Tommy Hofmann](https://www.thofma.com/).

You can ask questions in the [OSCAR Slack](https://www.oscar-system.org/community/#slack).

Alternatively, you can [raise an issue on github](https://www.oscar-system.org/community/#how-to-report-issues).
