# Linear quotients

## Aims

This project started with the thesis [Sch23].
The aim is to support work with linear quotients $V/G$ as affine varieties, that
is, anything that works with an affine scheme in OSCAR should work with a linear
quotient.
Of course, much more can be computationally done with a linear quotient due to
the additional structure.

## Status

The concrete goals and (minor or major) todos are the following:
* Make 'everything' one can do with an affine scheme possible for objects of type
`LinearQuotient`
* So far, we accept a matrix group in `linear_quotient(::MatrixGroup)` and then work
with the spectrum of the invariant ring. Following the (more or less implicit)
convention in the invariant theory code, this means that we actually construct the
linear quotient $V^\ast/G$, that is, we work with the dual representation.
We should decide, whether this is as desired.
* The function `cox_ring(::LinearQuotient)` should work for arbitrary groups, not just
for groups not containing reflections
* The function `cox_ring_of_qq_factorial_terminalization(::LinearQuotient)` should work
for arbitrary subgroups of $\operatorname{SL}_n$, not just for groups generated by
junior elements
* Address the numerous TODOs in the code
